function plot(oData,varargin)

%PLOT Linear plot. 
%   PLOT(oData, {'X1','Y1',legend}, {'X2','Y2',legend}, ..., options)
% 
%   It plots the X1 against Y1 on Y and X axes respectively.Similary X2 
%   against Y2 on the same plot.
%   Here X1,X2,Y1,Y2 are expressions in terms of state variables of the system.
%   If plot against time is required put 't' instead of the corresponding expression.
%   Depending on the values of fields in the odject it plots stochastic or
%   deterministic simualtion results.
%   Legend is optional.
%   Each plot has its own cell. If no cells are given as input, 
%   the output is plotted against time(time on X axis).
% 
%   options are the usual options for plot function.
%
% See also PLOT, DATA, PLOTMODEL, EXTRACTX.
%
% Version 1, October 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%


plotmodel(oData,varargin{1:end});