function status = CreateODEIntegrator(oModel)

%
% Version 1, october 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%

eval(sprintf('Mfile = fopen(''%s/%sODEIntegrator.m'',''r'');',oModel.tPath,oModel.tModelName));
if Mfile~=-1
    fprintf('File %s/%sODEIntegrator.m already exist. Do you want to overwrite it y/n [n]? ',oModel.tPath,oModel.tModelName);
        reply = input(' ','s');
        if isempty(reply)==1 || (reply=='N' || reply=='n')
            return
        end
end

eval(sprintf('Mfile = fopen(''%s/%sODEIntegrator.m'',''w'');',oModel.tPath,oModel.tModelName));

if Mfile==-1
    disp(' ')
    disp(['error while creating ' oModel.tModelName 'ODEIntegrator.m ']);
    disp(' ')
    status=0;
    return
end

SelectLibraryFolder;

class(oModel)
if strcmp(class(oModel),'modelinput')
    disp('Model with input for ODE')
    fprintf(Mfile,'function [T,X] = %sODEIntegrator(vTimeRange, vk, vX0, options, Infct)\n\n',oModel.tModelName);
else
    disp('Model without input for ODE')
    fprintf(Mfile,'function [T,X] = %sODEIntegrator(vTimeRange, vk, vX0, options)\n\n',oModel.tModelName);
end
fprintf(Mfile,'if nargin<3 || length(vk)~=%i || length(vX0)~=%i || length(vTimeRange)>3',oModel.slk,oModel.slX);
fprintf(Mfile,'\n\terror(''Incorrect arguments'')\nend\n\nlX=%i;\n',oModel.slX);


if strcmp(class(oModel),'modelinput')
    fprintf(Mfile,'\nfunction Input = zerofct(T)\n  Input=0*T;\n end\n\n');
    fprintf(Mfile,'if ~exist(''Infct'',''var'')\n');
    fprintf(Mfile,'Infct = @zerofct;\nend\n\n');
end

fprintf(Mfile,'function dX = F(t,X)\n');
if strcmp(class(oModel),'modelinput')
    fprintf(Mfile,'\tinput = Infct(t);\n');
end
fprintf(Mfile,'\tdX = X;\n');
fprintf(Mfile,'\n\t %% ... write ODE for all variables \n\n');
for i=1:oModel.slX
    fprintf(Mfile,'\tdX(%i) = . . . ; %% to be filled by hand !\n',i);
end
fprintf(Mfile,'\nend\n\n');


fprintf(Mfile,'function df = dFdX(t,X)\n');
if strcmp(class(oModel),'modelinput')
    fprintf(Mfile,'\tinput = Infct(t);\n');
end
fprintf(Mfile,'\tdf = zeros(lX,lX);\n');
fprintf(Mfile,'\n\t %% ... write ODE derivates for all variables \n\n');
for i=1:oModel.slX
    for j=1:oModel.slX
        fprintf(Mfile,'\tdf(%i,%i) = . . . ; %% to be filled by hand !\n',i,j);
    end
    fprintf(Mfile,'\n');
end
fprintf(Mfile,'\nend\n\n');


eval(sprintf('originalfile = fopen(''%s/FrameIntegrators/ODEIntegrator.m'',''r'');', LibraryFolder));

while 1
    tline = fgetl(originalfile);
    if ~isempty(findstr('special_tag_to_reconize_this_line', tline)), break, end
end

while 1
    tline = fgetl(originalfile);
    if ~ischar(tline),   break,   end
    fprintf(Mfile,'%s\n',tline);
end

fclose(originalfile);
status = fclose(Mfile);


if status~=0
    disp(' ')
    disp(['error while creating ' oModel.tModelName 'ODEIntegrator.m ']);
    disp(' ')
    status=0;
    return
else
    disp(' ')
    disp('Matlab ODE integrator file created')
    disp(['File is  ' oModel.tModelName 'ODEIntegrator.m ']);
    disp(['   in folder ' oModel.tPath]);
    disp(' ')
    status=1;
end



