function [T,X] = VariationalIntegrator(vTimeRange, vk, vX0, options)

if nargin<3 || length(vk)~= . . . || length(vX0)~= . . . || length(vTimeRange)>3
    T=0;X=0;
    disp('Incorrect arguments')
    return
end

    function dX = F(t,X)
        dX = X;
        dX(i) = . . . ;
    end

    function df = Dff(X)
        df = zeros(length(X),length(X));

        df(1,1) = . . . ;
        . . .
    end

% special_tag_to_reconize_this_line Do not remove !
% end of editable part of this file. Unless you want to optimize, leave
% the rest of this file original.

    function dX = FdF(t,X)
        dX = zeros(lX+lX*lX,1);

        dX(1:lX) = F(t,X(1:lX));
        df = dFdX(t,X(1:lX));

        for i=1:lX
            for j=1:lX
                for kk=1:lX
                    dX(lX*i+j) = dX(lX*i+j) + df(i,kk)*X(lX*kk +j);
                end
            end
        end
    end


for ii=1:lX
    for jj=1:lX
        vX0(lX*ii+jj) = ii==jj;
    end
end

if length(vTimeRange)==1
    X=FDF(vTimeRange,vX0);
    T=vTimeRange;
    return
else
    if length(vTimeRange)==3
        vTimeRange = [vTimeRange(1):vTimeRange(2):vTimeRange(3)];
    end
    if exist('options','var')
        [T,X]=ode45(@FdF,vTimeRange,vX0,options);
    else
        [T,X]=ode45(@FdF,vTimeRange,vX0);
    end
end

irelax = max([1; [1:length(T)]'.*(T<vTimeRange(1))]);
T=T(irelax:end);
X=X(irelax:end,:);

end
