%
% Version 1, october 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%

global bioSimworkingpath;

if exist('bioSimworkingpath','var')==0 || isempty(whos('global','bioSimworkingpath')) || isempty(bioSimworkingpath)

    if ispc
        % windows operating system
        if isempty(bioSimworkingpath)
            bioSimworkingpath = ['C:' filesep 'Users' filesep 'bioSim'];
        end

        if exist(bioSimworkingpath,'dir')==0
            try
                mkdir(bioSimworkingpath);
            catch
                disp(' ')
                disp(['Default working directory: ' bioSimworkingpath])
                disp(lasterror.message)
                disp('please set working directoy ')
                disp('use keyboard input to set variable  bioSimworkingpath  and type ''return''')
                keyboard

                try
                    if exist(bioSimworkingpath,'dir')==0
                        mkdir(bioSimworkingpath);
                    else
                        disp('working directory set')
                    end
                catch
                    disp(lasterror.message)
                    disp('please set an existing working directoy ')
                    disp('use keyboard input to set variable  bioSimworkingpath  and type ''return''')
                    keyboard

                    if exist(bioSimworkingpath,'dir')==0
                        error('Working directory does not exist!')
                    else
                        disp('working directory set')
                    end
                end
            end
        end
        
    else
        %mac operating system
        if isempty(bioSimworkingpath)
            bioSimworkingpath = '~/bioSim';
        end

        if exist(bioSimworkingpath,'dir')==0
            try
                mkdir(bioSimworkingpath);
            catch
                disp(' ')
                disp(['Default working directory: ' bioSimworkingpath])
                disp(lasterror.message)
                disp('please set working directoy ')
                disp('use keyboard input to set variable  bioSimworkingpath  and type ''return''')
                keyboard

                try
                    if exist(bioSimworkingpath,'dir')==0
                        mkdir(bioSimworkingpath);
                    else
                        disp('working directory set')
                    end
                catch
                    disp(lasterror.message)
                    disp('please set an existing working directoy ')
                    disp('use keyboard input to set variable  bioSimworkingpath  and type ''return''')
                    keyboard

                    if exist(bioSimworkingpath,'dir')==0
                        error('Working directory does not exist!')
                    else
                        disp('working directory set')
                    end
                end
            end
        end
    end
    

    if bioSimworkingpath(end)=='\' || bioSimworkingpath(end)=='/'
        bioSimworkingpath=bioSimworkingpath(1:end-1);
    end
    
    slash = sort((bioSimworkingpath=='/').*[1:length(bioSimworkingpath)],'descend');
    slash = slash(1:max((slash~=0).*[1:length(slash)]));
    for i=1:length(slash)
        bioSimworkingpath(slash(i)) = filesep;
    end
        
    slash = sort((bioSimworkingpath=='\').*[1:length(bioSimworkingpath)],'descend');
    slash = slash(1:max((slash~=0).*[1:length(slash)]));
    for i=1:length(slash)
        bioSimworkingpath(slash(i)) = filesep;
    end
    
    clear slash
  
end

if exist([bioSimworkingpath filesep 'backup'],'dir')==0
    try
        mkdir([bioSimworkingpath filesep 'backup']);
    catch
        disp('unable to create backup directory')
    end
end

if exist([bioSimworkingpath filesep 'models'],'dir')==0
    try
        mkdir([bioSimworkingpath filesep 'models']);
    catch
        disp('unable to create models directory')
    end
end

if exist([bioSimworkingpath filesep 'temp'],'dir')==0
    try
        mkdir([bioSimworkingpath filesep 'temp']);
    catch
        disp('unable to create temp directory')
    end
end